import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;

/**
 * Write a description of class Game here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Game extends Thread
{
    private int[] players;

    private Board board;
    
    private myWorld world;
    
    private int local_WID;

    //turn will oscillate between 1 and 2.
    private int turn = 1;
    private int true_turn = 1;

    private int isGameOver;

    //ais are numbered
    //one is human, two is alphabetaO
    public Game(int one, int two, myWorld world) {
        players = new int[2];
        players[0] = one;
        players[1] = two;
        isGameOver = 0;
        this.world = world;
        local_WID = world.GLOBAL_WID;
        board = new Board();
    }
    public void runAIThread(int player, Board b, int ai) {
        switch (ai) {
            case 2: (new AlphaBetaO(player, b, world)).start(); break;
            default: (new Human(player, b, world)).start();
        }
    }
    public void run() {
        System.out.println("Started Game Thread with WorldID: " + local_WID);
        while(isGameOver==0) {
            if (local_WID != myWorld.GLOBAL_WID) {
                System.out.println("Ended Game Thread with WorldID: " + local_WID 
                    + " Current WorldID: " + myWorld.GLOBAL_WID);
                return;
            }
                
            Human.madeMove = false; //allow the human player to make a move
            
            //this game is only designed for one human player.
            System.out.println("\n*****Turn: " +true_turn + "*****");
            //System.out.println(board.getPossibleMoves());
            //System.out.println("");
            int move;
            runAIThread(turn, board, players[turn-1]);
            while(AI.madeMove == false) {
                try {
                    sleep(100);
                } catch(Exception e) {
                    e.printStackTrace();
                }
                if (local_WID != myWorld.GLOBAL_WID) {
                    System.out.println(
                        "Ended Game Thread with WorldID: " + local_WID
                            + " Current WorldID: " + myWorld.GLOBAL_WID);
                    return;
                }
            }
            
            move = AI.move;
            AI.madeMove = false;
            //int move = players[turn-1].generateMove(turn, board);
            System.out.println("Move: " + move);
            board.makeMove(turn, move);
            world.addPiece(turn, move);
            //System.out.println(board);

            //System.out.println("Rows: " + board.getRowsAsStr());
            //System.out.println("Cols: "+ board.getColsAsStr());
            //System.out.println("Diags: "+board.getDiagsAsStr());

            this.isGameOver = board.isGameOver();

            true_turn++;
            turn++;
            if (turn == 3) {
                turn = 1;
            }
        }
        System.out.println("Player " + isGameOver
                + (isGameOver == 1 ? " (X)" : " (O)") + " wins!");
                
        System.out.println("Ended Game Thread with WorldID: " + local_WID
            + " Current WorldID: " + myWorld.GLOBAL_WID);
        //Greenfoot.stop();
    }
}
